<?php

namespace App\Models;

use Illuminate\Support\Str;

use Spatie\Permission\Traits\HasRoles;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;
use Illuminate\Database\Eloquent\SoftDeletes;
use Deligoez\LaravelModelHashId\Traits\HasHashId;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Category extends Model
{
    /** @use HasFactory<\Database\Factories\UserFactory> */
    use HasFactory, Notifiable, HasHashId, HasRoles, SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var list<string>
     */
    protected $guarded = [];

    /**
     * Relations
     */

    // Utilisateur qui a créé la catégorie
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    // Produits de cette catégorie
    public function products()
    {
        return $this->hasMany(Product::class);
    }

    //Créer une fonction pour générer une référence unique pour la catégorie
    public static function generateReference()
    {
        return 'CAT-00' . strtoupper(Str::random(2));
    }
}
